﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="TemplateFieldMultiColumnDropDown.WebForm1" %>

<%@ Register Assembly="Infragistics45.Web.v21.2, Version=21.2.20212.9, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>

<%@ Register Assembly="Infragistics45.Web.v21.2, Version=21.2.20212.9, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style>
        .igg_HeaderCaption {
        font-size: 12px;
        padding: 5px 0px 5px 8px;
        overflow: hidden;
        text-align: left;
        height: 25px;
        font-family: Verdana;
        font-weight: normal;
        border-top: 1px solid #777777;
        border-right: 1px solid #777777;
        border-bottom: 1px solid #777777;
        border-left: 1px solid #888888;
        color: #FFFFFF;
        background-color: #888888;
    }

    .igdd_ListItem {
        border-style: solid;
        border-color: #FFFFFF #CCCCCC #CCCCCC #CCCCCC;
        border-width: 1px;
    }

    .igdd_ListItem:nth-child(odd) {
        background-color: #F6F6F6;
    }

    .igdd_ListItemHover {
        background-color: #CCCCCC !important;
    }

    .igdd_ListItemActive {
        background-color: #9ECBD6 !important;
        border: solid 1px #CCCCCC;
    }
    </style>
</head>
<body>
    <form id="form1" runat="server">        
        <div>
            <asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
             <ig:WebDataGrid ID="WebDataGrid1" runat="server" Height="600px" Width="1000px" AutoGenerateColumns="False" DataKeyFields="ID"
                  OnInitializeRow="WebDataGrid1_InitializeRow">
                <Columns>
                    <ig:BoundDataField DataFieldName="ID" Key="ID">
                        <Header Text="ID"/>
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="Name" Key="Name">
                        <Header Text="Name"/>
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="Age" Key="Age">
                        <Header Text="Age"/>
                    </ig:BoundDataField>
                    <ig:TemplateDataField Key="Supervisor" Header-Text="Supervisor">
                        <ItemTemplate>
                            <ig:WebDropDown ID="wdd" runat="server" TextField="Name" Width="180px" DataKeyFields="ID" DropDownContainerWidth="300px"                            
                            AutoSelectOnMatch="true"
                            EnableAutoCompleteFirstMatch="False"
                            EnableClosingDropDownOnSelect="true">

                            <ClientEvents ValueChanged="dd_ValueChanged"/>

                            <HeaderTemplate>
                                <table id="TemplateContainer">
                                    <tr class="igg_row">
                                    <td class="igg_HeaderCaption" style="width: 100px;">ID</td>
                                    <td class="igg_HeaderCaption" style="width: 100px;">Name</td>
                                    <td class="igg_HeaderCaption" style="width: 100px;">Age</td>
                                    </tr>
                                    </table>
                            </HeaderTemplate>
                              <ItemTemplate>
                                    <table style="width: 100%;">
                                        <tr class="igg_row">
                                        <td style="width: 100px;">
                                        <%# DataBinder.Eval(Container.DataItem, "ID")%>
                                        </td>
                                        <td style="width: 100px;">
                                        <%# DataBinder.Eval(Container.DataItem, "Name")%>
                                        </td>
                                        <td style="width: 100px;">
                                        <%# DataBinder.Eval(Container.DataItem, "Age")%>
                                        </td>
                                        </tr>
                                </table>
                            </ItemTemplate>
                        </ig:WebDropDown>
                    </ItemTemplate>
                    </ig:TemplateDataField>
                    <ig:UnboundField Key="SupervisorAge">
                        <Header Text="Supervisor Age"/>
                    </ig:UnboundField>
                </Columns>             
                <Behaviors>
                    <ig:EditingCore>
                        <Behaviors>
                            <ig:CellEditing CellEditingClientEvents-EnteredEditMode="wdg_EnteredEditMode">                               
                            </ig:CellEditing>
                        </Behaviors>
                    </ig:EditingCore>
                    <ig:Selection>
                    </ig:Selection>
                    <ig:Activation>
                    </ig:Activation>
                </Behaviors>
            </ig:WebDataGrid>           
        </div>
    </form>
    <script>

        function wdg_EnteredEditMode(sender, e) {
            console.log("Entered edit mode in the following column: " + e.getCell().get_column().get_key());
        }

        function dd_ValueChanged(sender, e) { 
            var grid = $find("WebDataGrid1")
            var wdd = sender;
            var value = e.get_value();            
            var selectedItemIndex = wdd.get_selectedItemIndex();  
            var data = <%= ConvertDataTabletoString()%>;            
            var supervisorAge = data[selectedItemIndex].Age;
            var rowIndex = wdd.get_element().parentElement.parentElement._object.get_index();
            var row = grid.get_rows().get_row(rowIndex);
            
            row.get_cell(4).set_value(supervisorAge);
            // enter edit mode on a cell
            grid.get_behaviors().get_editingCore().get_behaviors().get_cellEditing().enterEditMode(row.get_cell(4));
        }
    </script>
</body>
</html>
